import processing.sound.*;
import processing.sound.SoundFile;
import processing.serial.*;
SoundFile menuMusic;
SoundFile rouge;
SoundFile bleu;
SoundFile jaune;
SoundFile vert;
SoundFile perdu;
SoundFile eatserEGG;
IntList indcareclic;
IntList indcarejeux;
int s1carGH;
int s2carGH;
int s1carDH;
int s2carDH;
int s1carGB;
int s2carGB;
int s1carDB;
int s2carDB;
int numberclick;
int numberround;
int ind;
boolean isloosing = false;
boolean hasDeathBeenPlayedOnce = false;
PFont comic;
int score;
boolean isstilltaken = false;
boolean needToDraw = true;
int colbc = 200;
boolean isDrawingSeq = false;
boolean needtoplayrouge = true;
boolean needtoplaybleu = true;
boolean needtoplayjaune = true;
boolean needtoplayvert = true;
boolean allowedToPlay = true;

SettingsJSON settingsShits;

MainMenu mainMenu;
boolean isInMainMenu = true;
boolean needToPlay = false;
SettingsMenu settings;
SettingsJSON settingsFiles;
boolean needToSwitchToSettings = false;
GameOver gameOver;

void setup() {
  size(800,800);
  surface.setLocation(displayWidth/2-width/2, displayHeight/2-height/2);   // Pour éviter les problèmes de fenêtre
  settingsShits = new SettingsJSON();
  settingsShits.loadSettings();
  mainMenu = new MainMenu();
  if(settingsShits.darkMode){
    mainMenu.fillPlayButton = 38;
    mainMenu.fillMenuButton = 38;
  }
  else{
    mainMenu.fillMenuButton = 255;
    mainMenu.fillPlayButton = 255;
  }
  settings = new SettingsMenu();
  gameOver = new GameOver();
  settings.setArray[0] = "darkmode";
  settings.setArray[1] = "chaosmode";
  menuMusic = new SoundFile(this, "data/title.mp3");
  menuMusic.amp(0.6);
  rouge = new SoundFile(this, "data/rouge.mp3");
  bleu = new SoundFile(this, "data/bleu.mp3");
  jaune = new SoundFile(this, "data/jaune.mp3");
  vert = new SoundFile(this, "data/vert.mp3");
  perdu = new SoundFile(this, "data/perdu.mp3");
  eatserEGG = new SoundFile(this, "data/ui.mp3");
  eatserEGG.amp(0.8);
  indcareclic = new IntList();
  indcarejeux = new IntList();
  indcarejeux.append(int(random(0, 4)));
  ind = 0;
  comic = createFont("COMIC.TTF", 10);
  textFont(comic);
}

void draw() {
  if (isInMainMenu && !needToPlay && !needToSwitchToSettings) {
    if (!menuMusic.isPlaying() && allowedToPlay) {
      menuMusic.play();
    }
    mainMenu.draw();
    isloosing = mainMenu.isDead;
    needToPlay = mainMenu.isPlayGame;
    needToSwitchToSettings = mainMenu.isSettings;
    if (needToPlay || needToSwitchToSettings) {
      isInMainMenu = false;
      isloosing = false;

      score = 0;
    }
  } else if (needToSwitchToSettings && !isInMainMenu && !needToPlay) {
    if (!menuMusic.isPlaying() && allowedToPlay) {
      menuMusic.play();
    }
    settings.draw();
    isInMainMenu = settings.needToGoInMenu;
    if (isInMainMenu) {
      settingsShits.loadSettings();
      needToSwitchToSettings = false;
      isloosing = false;
    }
  } else if (!isloosing && !isInMainMenu && !needToSwitchToSettings && needToPlay) {
    if (menuMusic.isPlaying()) {
      menuMusic.stop();
    }
    surface.setTitle("LE JEU");
    needToPlay = true;
    isloosing = false;
    background(colbc);
    s2carGH = millis();
    s2carDH = millis();
    s2carGB = millis();
    s2carDB = millis();
    isstilltaken = false;
    needtoplayrouge = true;
    needtoplaybleu = true;
    needtoplayjaune = true;
    needtoplayvert = true;

    strokeWeight(0);
    fill(colbc);
    rectMode(CENTER);
    rect(width / 2, height / 2, width, height);

    strokeWeight(10);
    ellipse(width / 2, height / 2, width - 10, height - 10);
    fill(0, 0, 255);
    arc(width / 2, height / 2, width - 10, height - 10, 0, HALF_PI);
    fill(255, 255, 0);
    arc(width / 2, height / 2, width - 10, height - 10, HALF_PI, PI);
    fill(0, 255, 0);
    arc(width / 2, height / 2, width - 10, height - 10, -PI, -HALF_PI);
    fill(255, 0, 0);
    arc(width / 2, height / 2, width - 10, height - 10, -HALF_PI, 0);
    fill(0, 0, 0, 125);
    ellipse(width / 2, height / 2, width - 10, height - 10);

    fill(0);
    stroke(0);
    line(width / 2, height / 3, width / 2, 5);
    line(width / 2, height - height / 3, width / 2, height - 5);
    line(width / 3, height / 2, 5, height / 2);
    line(width - width / 3, height / 2, width - 5, height / 2);

    isDrawingSeq = true;
    if (!isstilltaken) {
      if ((s1carGH + 500 > s2carGH)) {
        needtoplaybleu = false;
        drawcarre(3, false);
        isstilltaken = true;
      }
      if ((s1carDH + 500 > s2carDH)) {
        needtoplayjaune = false;
        drawcarre(2, false);
        isstilltaken = true;
      }
      if ((s1carDB + 500 > s2carDB)) {
        needtoplayrouge = false;
        drawcarre(1, false);
        isstilltaken = true;
      }
      if ((s1carGB + 500 > s2carGB)) {
        needtoplayvert = false;
        drawcarre(0, false);
        isstilltaken = true;
      }
    }
    isDrawingSeq = false;

    fill(colbc);

    verify();

    stroke(0);
    ellipse(width / 2, height / 2, width / 3, height / 3);
    fill(0);
    comic = createFont("COMIC.TTF", 52);
    textAlign(CENTER);
    textFont(comic);
    text("score: " + str(score), width / 2, height / 2);
  } else {
    if (!(rouge.isPlaying() && vert.isPlaying() && bleu.isPlaying() && jaune.isPlaying())) {
      if (!hasDeathBeenPlayedOnce) {
        perdu.play();
        hasDeathBeenPlayedOnce = true;
      }
    }
    gameOver.draw(score);
    isInMainMenu = gameOver.goToMenu;
    needToPlay = gameOver.retry;
    if (isInMainMenu) {
      isloosing = false;
      needToPlay = false;
    }
    if (needToPlay) {
      isloosing = false;
    }
  }
}

void mousePressed() {
  color couleurpoint = get(mouseX, mouseY);
  if (numberclick >= numberround && !isloosing && !needToDraw) {
    boolean canDoTheThings = false;
    switch(couleurpoint) {
    case - 16743936:
      indcareclic.append(0);
      drawcarre(0, true);
      canDoTheThings = true;
      break;
    case - 16711936:
      indcareclic.append(0);
      drawcarre(0, true);
      canDoTheThings = true;
      break;
    case - 8257536:
      indcareclic.append(1);
      drawcarre(1, true);
      canDoTheThings = true;
      break;
    case - 65536:
      indcareclic.append(1);
      drawcarre(1, true);
      canDoTheThings = true;
      break;
    case - 8224256:
      indcareclic.append(2);
      drawcarre(2, true);
      canDoTheThings = true;
      break;
    case - 256:
      indcareclic.append(2);
      drawcarre(2, true);
      canDoTheThings = true;
      break;
    case - 16777086:
      indcareclic.append(3);
      drawcarre(3, true);
      canDoTheThings = true;
      break;
    case - 16776961:
      indcareclic.append(3);
      drawcarre(3, true);
      canDoTheThings = true;
      break;
    }
    if (settingsShits.chaosMode && canDoTheThings) {
      surface.setLocation(int(random(0, displayWidth-width)), int(random(0, displayHeight-height)));
    }
  }
}

void keyPressed() {
  println(key, keyCode); // 32 = epace
  //println("désactivé");
  if (keyCode ==  32) {
    allowedToPlay = false;
    mainMenu.allowedToPlay = false;
    settings.allowedToPlay = false;
    if (!eatserEGG.isPlaying()) {
      println(menuMusic.isPlaying());
      if (menuMusic.isPlaying()) {
        menuMusic.stop();
      }
      eatserEGG.play();
    } else {
      if (menuMusic.isPlaying()) {
        menuMusic.stop();
      }
      eatserEGG.stop();
      eatserEGG.play();
    }
  }
  if (keyCode == 8) {
    eatserEGG.stop();
    if (isInMainMenu || needToSwitchToSettings) {
      allowedToPlay = true;
    }
  }
  if (needToSwitchToSettings) {
    if (int(key) == 10) {
      settingsShits.changeSettings(settings.setArray[settings.curSelected]);
    }
    if (keyCode==38) {
      settings.curSelected--;
    }
    if (keyCode==40) {
      settings.curSelected++;
    }
  }
}

void drawcarre(int nocarr, boolean canPlay) {
  strokeWeight(1);
  switch(nocarr) {
  case 0:
    fill(0, 255, 0);
    arc(width / 2, height / 2, width - 10, height - 10, -PI, -HALF_PI);
    if (!isDrawingSeq) {
      s1carGB = millis();
    }

    if (canPlay) {
      vert.play();
    } else {
      if (!vert.isPlaying() && needtoplayvert) {
        vert.play();
      }
    }

    break;
  case 1:
    fill(255, 0, 0);
    arc(width / 2, height / 2, width - 10, height - 10, -HALF_PI, 0);
    if (!isDrawingSeq) {
      s1carDB = millis();
    }

    if (canPlay) {
      rouge.play();
    } else {
      if (!rouge.isPlaying() && needtoplayrouge) {
        rouge.play();
      }
    }
    break;
  case 2:
    fill(255, 255, 0);
    arc(width / 2, height / 2, width - 10, height - 10, HALF_PI, PI);
    if (!isDrawingSeq) {
      s1carDH = millis();
    }

    if (canPlay) {
      jaune.play();
    } else {
      if (!jaune.isPlaying() && needtoplayjaune) {
        jaune.play();
      }
    }
    break;
  case 3:
    fill(0, 0, 255);
    arc(width / 2, height / 2, width - 10, height - 10, 0, HALF_PI);
    if (!isDrawingSeq) {
      s1carGH = millis();
    }

    if (canPlay) {
      bleu.play();
    } else {
      if (!bleu.isPlaying() && needtoplaybleu) {
        bleu.play();
      }
    }

    break;
  }
  strokeWeight(10);
  fill(colbc);
  ellipse(width / 2, height / 2, width / 3, height / 3);
  noFill();
  ellipse(width / 2, height / 2, width - 10, height - 10);
  stroke(0);
  line(width / 2, height / 3, width / 2, 5);
  line(width / 2, height - height / 3, width / 2, height - 5);
  line(width / 3, height / 2, 5, height / 2);
  line(width - width / 3, height / 2, width - 5, height / 2);
}

void verify() {
  if ((indcareclic.size() <= indcarejeux.size())) {   // Vérification en temps réel, 60*fois seconde
    for (int i = 0; i < indcareclic.size(); i++) {
      if (indcareclic.get(i) != indcarejeux.get(i)) {
        isloosing = true;
        needToPlay = false;
        indcarejeux.clear();
        indcareclic.clear();
      }
    }
  }

  if ((indcareclic.size() == indcarejeux.size())/* && !indcarejeux.size()*/) {
    needToDraw = true;
    if (!isloosing) {
      score = indcareclic.size();
      indcareclic = new IntList();
      if (settingsShits.chaosMode) {
        int templenght = indcarejeux.size();
        indcarejeux = new IntList();
        for (int i = 0; i <= templenght; i++) {
          indcarejeux.append(int(random(0, 4)));
        }
      } else {
        indcarejeux.append(int(random(0, 4)));
      }
      delay(500);
    }
  }

  if (needToDraw) {
    if (!isstilltaken) {
      delay(200);
      if (ind>indcarejeux.size() - 1) {
        ind = indcarejeux.size() - 1;
      }
      drawcarre(indcarejeux.get(ind), false);
      ind++;
    }
    if (ind ==  indcarejeux.size()) {
      needToDraw = false;
      ind = 0;
    }
  }
}
